var j = Object.defineProperty;
var E = (s, o, a) => o in s ? j(s, o, { enumerable: !0, configurable: !0, writable: !0, value: a }) : s[o] = a;
var w = (s, o, a) => (E(s, typeof o != "symbol" ? o + "" : o, a), a);
const T = (s, o) => {
  const a = s[o];
  return a ? typeof a == "function" ? a() : Promise.resolve(a) : new Promise((x, c) => {
    (typeof queueMicrotask == "function" ? queueMicrotask : setTimeout)(c.bind(null, new Error("Unknown variable dynamic import: " + o)));
  });
}, $ = {
  num: {
    type: "num",
    match: /(\.e?|\b)\d(e-|[\d.oxa-fA-F_])*(\.|\b)/g
  },
  str: {
    type: "str",
    match: /(["'])(\\[^]|(?!\1)[^\r\n\\])*\1?/g
  },
  strDouble: {
    type: "str",
    match: /"((?!")[^\r\n\\]|\\[^])*"?/g
  }
};
class I {
  constructor() {
    w(this, "lastIndex", 0);
  }
  exec(o) {
    return null;
  }
}
const L = [
  [
    "bash",
    [/#!(\/usr)?\/bin\/bash/g, 500],
    [/\b(if|elif|then|fi|echo)\b|\$/g, 10]
  ],
  ["html", [/<\/?[a-z-]+[^\n>]*>/g, 10], [/^\s+<!DOCTYPE\s+html/g, 500]],
  ["http", [/^(GET|HEAD|POST|PUT|DELETE|PATCH|HTTP)\b/g, 500]],
  [
    "js",
    [
      /\b(console|await|async|function|export|import|this|class|for|let|const|map|join|require)\b/g,
      10
    ]
  ],
  [
    "ts",
    [
      /\b(console|await|async|function|export|import|this|class|for|let|const|map|join|require|implements|interface|namespace)\b/g,
      10
    ]
  ],
  ["py", [/\b(def|print|class|and|or|lambda)\b/g, 10]],
  ["sql", [/\b(SELECT|INSERT|FROM)\b/g, 50]],
  ["pl", [/#!(\/usr)?\/bin\/perl/g, 500], [/\b(use|print)\b|\$/g, 10]],
  ["lua", [/#!(\/usr)?\/bin\/lua/g, 500]],
  [
    "make",
    [/\b(ifneq|endif|if|elif|then|fi|echo|.PHONY|^[a-z]+ ?:$)\b|\$/gm, 10]
  ],
  ["uri", [/https?:|mailto:|tel:|ftp:/g, 30]],
  ["css", [/^(@import|@page|@media|(\.|#)[a-z]+)/gm, 20]],
  ["diff", [/^[+><-]/gm, 10], [/^@@ ?[-+,0-9 ]+ ?@@/gm, 25]],
  ["md", [/^(>|\t\*|\t\d+.)/gm, 10], [/\[.*\](.*)/g, 10]],
  ["docker", [/^(FROM|ENTRYPOINT|RUN)/gm, 500]],
  ["xml", [/<\/?[a-z-]+[^\n>]*>/g, 10], [/^<\?xml/g, 500]],
  ["c", [/#include\b|\bprintf\s+\(/g, 100]],
  ["rs", [/^\s+(use|fn|mut|match)\b/gm, 100]],
  ["go", [/\b(func|fmt|package)\b/g, 100]],
  ["java", [/^import\s+java/gm, 500]],
  ["asm", [/^(section|global main|extern|\t(call|mov|ret))/gm, 100]]
];
function R(s) {
  var c;
  return ((c = L.map(([h, ...u]) => {
    const y = u.reduce(
      (f, [t, e]) => {
        var i;
        return f + (((i = s.match(new RegExp(t, "g"))) == null ? void 0 : i.length) || 0) * e;
      },
      0
    );
    return [h, y];
  }).filter(([h, u]) => u >= 20).sort(
    ([h, u], [y, f]) => f - u
  )[0]) == null ? void 0 : c[0]) || "plain";
}
var v;
((s) => {
  const o = {
    show_title: !0,
    hide_line_numbers: !1,
    trim: !1
  };
  let a = o;
  s.languages = {};
  function x(t) {
    var e, i, g, l;
    return (l = (i = (e = t.replaceAll("&", "&#38;")).replaceAll) == null ? void 0 : (g = i.call(e, "<", "&lt;")).replaceAll) == null ? void 0 : l.call(g, ">", "&gt;");
  }
  s.sanitize = x;
  function c(t, e) {
    return e ? `<span class="shjs-syn-${e}">${t}</span>` : t;
  }
  s.to_span = c;
  async function h(t, e, i) {
    var g;
    try {
      let l;
      typeof e == "string" ? l = await ((g = s.languages)[e] ?? (g[e] = await T(/* @__PURE__ */ Object.assign({ "./languages/asm.ts": () => import("./asm-379ba160.js"), "./languages/bash.ts": () => import("./bash-015e7dec.js"), "./languages/bf.ts": () => import("./bf-aa15c0c7.js"), "./languages/c.ts": () => import("./c-af18f50b.js"), "./languages/css.ts": () => import("./css-e64ee7ce.js"), "./languages/csv.ts": () => import("./csv-76a588d2.js"), "./languages/diff.ts": () => import("./diff-aec35e8c.js"), "./languages/docker.ts": () => import("./docker-5097d762.js"), "./languages/git.ts": () => import("./git-8f4b3dae.js"), "./languages/go.ts": () => import("./go-021f6b4b.js"), "./languages/html.ts": () => import("./html-9b836012.js"), "./languages/http.ts": () => import("./http-df1e3b03.js"), "./languages/ini.ts": () => import("./ini-5d10b777.js"), "./languages/java.ts": () => import("./java-243f4a1b.js"), "./languages/js.ts": () => import("./js-6df0c4c6.js"), "./languages/js_template_literals.ts": () => import("./js_template_literals-66d1c0c4.js"), "./languages/jsdoc.ts": () => import("./jsdoc-ae526b45.js"), "./languages/json.ts": () => import("./json-09f5a37f.js"), "./languages/leanpub-md.ts": () => import("./leanpub-md-bcd028d8.js"), "./languages/log.ts": () => import("./log-555045a2.js"), "./languages/lua.ts": () => import("./lua-caf2eaa5.js"), "./languages/make.ts": () => import("./make-8539a036.js"), "./languages/md.ts": () => import("./md-f2cc006f.js"), "./languages/pl.ts": () => import("./pl-0721bfcf.js"), "./languages/plain.ts": () => import("./plain-bca357dc.js"), "./languages/py.ts": () => import("./py-dab73c47.js"), "./languages/regex.ts": () => import("./regex-9ed70c94.js"), "./languages/rs.ts": () => import("./rs-6068a719.js"), "./languages/sql.ts": () => import("./sql-40e76724.js"), "./languages/todo.ts": () => import("./todo-844da562.js"), "./languages/toml.ts": () => import("./toml-2817dc06.js"), "./languages/ts.ts": () => import("./ts-25a1f69e.js"), "./languages/uri.ts": () => import("./uri-89a58c02.js"), "./languages/xml.ts": () => import("./xml-ea692477.js"), "./languages/yaml.ts": () => import("./yaml-1ed06a89.js") }), `./languages/${e}.ts`))) : l = e;
      const m = Array.from(
        typeof e == "string" ? l.default : e.sub
      );
      let b, n = {
        index: null,
        match: "",
        end: 0,
        part: {}
      };
      const p = [];
      let d = 0, _;
      for (; d < t.length; ) {
        n.index = null;
        for (let r = m.length; r-- > 0; ) {
          if (b = m[r].expand ? $[m[r].expand] : m[r], p[r] === void 0 || p[r].match.index < d) {
            if (b.match.lastIndex = d, _ = b.match.exec(t), _ === null) {
              m.splice(r, 1), p.splice(r, 1);
              continue;
            }
            p[r] = { match: _, lastIndex: b.match.lastIndex };
          }
          p[r].match[0] && (n.index === null || p[r].match.index <= n.index) && (n = {
            part: b,
            index: p[r].match.index,
            match: p[r].match[0],
            end: p[r].lastIndex
          });
        }
        if (n.index === null)
          break;
        i(t.slice(d, n.index), l.type), d = n.end, n.part.sub ? await h(
          n.match,
          typeof n.part.sub == "string" ? n.part.sub : typeof n.part.sub == "function" ? n.part.sub(n.match) : n.part,
          i
        ) : i(n.match, n.part.type);
      }
      i(t.slice(d, t.length), l.type);
    } catch (l) {
      console.error(l);
    }
  }
  s.tokenize = h;
  async function u(t, e, i = !0) {
    let g = "";
    return a.trim && (t = t.trim()), await h(
      t,
      e,
      (l, m) => g += c(x(l), m)
    ), i ? `<div><div class="shjs-numbers">${"<div></div>".repeat(
      a.hide_line_numbers ? 0 : t.split(`
`).length
    )}</div><div>${g}</div></div>` : g;
  }
  s.highlight_text = u;
  async function y(t, e = ((g) => (g = t.className.match(/shj-lang-([\w-]+)/)) == null ? void 0 : g[1])(), i) {
    let l = t.textContent;
    l !== null && (i ?? (i = `${t.tagName == "CODE" ? "in" : l.split(`
`).length < 2 ? "one" : "multi"}line`), t.dataset.lang = e, t.className = `${Array.from(t.classList).filter(
      (m) => !m.startsWith("shjs-") || m.startsWith("shjs-mode-")
    ).join(" ")}shjs-lang-${e} shjs-${i}`, console.log(a.show_title + "LOL"), a.show_title && t.classList.add("shjs-title"), t.innerHTML = await u(l, e, i === "multiline"));
  }
  s.highlight_element = y;
  function f(t) {
    a = { ...o, ...t }, console.log(a);
  }
  s.set_options = f;
})(v || (v = {}));
const N = v;
export {
  I as CustomRegex,
  N as default,
  R as detect_language
};
