import { DisplayMode, InternalLanguage, InternalLanguageDef, Language, Options, Token } from './types';
export * from './types';
export * from './detect';
declare namespace shjs {
    export const languages: {
        [key: string]: DynamicImport;
    };
    export function sanitize(str: string): string;
    export function to_span(str: string, token?: Token): string;
    type DynamicImport = {
        default: InternalLanguageDef;
        type?: Token;
    };
    export function tokenize(str: string, language: Language | InternalLanguage, token_callback: (name: string, token?: Token) => void): Promise<void>;
    export function highlight_text(str: string, lang: Language, multiline?: boolean): Promise<string>;
    export function highlight_element(elm: HTMLElement, lang?: Language, mode?: DisplayMode): Promise<void>;
    export function set_options(opt: Options): void;
    export {};
}
export default shjs;
